#include "crtlocal.h"
#ifdef THINK_C
#include <LoMem.h>
#include <THINK.h>
#define get_time() TimeLM
#define get_ticks() Ticks
#else
#include <Types.h>
#include <Errors.h>
#include <Memory.h>
#include <OSUtils.h>
#include <SegLoad.h>
#include <Quickdraw.h>
#include <Files.h>
#include <Menus.h>
#include <Fonts.h>
#include <Resources.h>
#include <GestaltEqu.h>
#include <Traps.h>
#include <Aliases.h>
#include <Packages.h>
#include <Processes.h>
#include <AppleEvents.h>
#include <ToolUtils.h>
#include <SysEqu.h>
#define get_time() (*(long *)TimeLM)
#define get_ticks() (*(long *)Ticks)
enum {FALSE,TRUE};
#endif
#include <fcntl.h>
#include <sys/syslimits.h>
#include <string.h>
#include <Events.h>

struct crt_fd_tab	crt_fd_tab[OPEN_MAX+1];
FSSpec                          crt,root;
WindowPtr			crt_myWindow;
TEHandle			crt_TEH;
int					crt_sizeof_qd = sizeof(qd);

static char *default_environ[] = {"LOGNAME=jrrk",NULL};

char **environ = default_environ;

int _fmode = 0;

int getdtablesize(void)
	{
	mysleep(1);
	return OPEN_MAX;
	}

int getpagesize(void)
	{
	mysleep(1);
	return 8192;
	}

char *getwd(char *fullname)
    {
	char *idx;
    static char sfullname[256];
    char crt_defpath[256];
    OSErr err;
    CInfoPBRec  cPB;
    cPB.dirInfo.ioDrParID = crt.parID;
    crt_defpath[0] = 0;
	do
		{
		char tmp[256];
        strcpy(tmp,crt_defpath);
        /* get information about dir */
        cPB.hFileInfo.ioCompletion = (ProcPtr)0L;
        cPB.hFileInfo.ioNamePtr = (StringPtr)crt_defpath;
        cPB.hFileInfo.ioVRefNum = crt.vRefNum;
        cPB.hFileInfo.ioFDirIndex = -1;
		cPB.hFileInfo.ioDirID = cPB.dirInfo.ioDrParID;

        err = PBGetCatInfoSync(&cPB); 
		strcpy(crt_defpath+1+*crt_defpath,tmp);
        crt_defpath[0] = '/';
		}
	while ( /* (cPB.dirInfo.ioDrParID != 2) && */ !err);
	idx = strchr(crt_defpath+1, '/');
	if (!idx) strcpy(sfullname, "/");
    else strcpy(sfullname, idx);
    if (fullname) strcpy(fullname, sfullname);
    else fullname = sfullname;
    return fullname;
	}

int next_fd(int first)
	{
	int i;
	for (i = first; i < OPEN_MAX; i++)
		if (!crt_fd_tab[i].fd) return i;
	}
	
gettimeofday(struct timeval *ktime, struct timezone *kzone)
		{
		memset(kzone, 0, sizeof(*kzone));
		ktime->tv_sec = unixTime(get_time());
		ktime->tv_usec = (get_ticks()%60)*1000000/60;
		}
