#ifndef THINK_C
#define SystemSevenOrLater 1
#endif
#include <Scrap.h>
#include <Processes.h>
#include <Files.h>
#include <AppleEvents.h>
#include <Quickdraw.h>
#include <Menus.h>
#include <Windows.h>
#include <ToolUtils.h>
#include <Desk.h>
#include <SegLoad.h>
#include <OSUtils.h>
#include <Memory.h>
#include <Fonts.h>
#include <Events.h>
#include <OSEvents.h>
#include <TextEdit.h>
#include <Dialogs.h>
#include <Aliases.h>
#include <Folders.h>
#include <Errors.h>
#include <GestaltEqu.h>
#include <StandardFile.h>

#include <string.h>
#include "crtlocal.h"

OSErr GotRequiredParams(AppleEvent *);
void scanfolder(FSSpec *);
void main(void);
void SetUpMenus(void);
void AdjustMenus(void);
void HandleMenu(long);
void SetUpWindow(void);
void InitMacintosh(void);
void HandleMouseDown(EventRecord *);
void HandleEvent(void);
void BeginProcessing(void);
void EndProcessing(void);
void ProcessDoc (FSSpec *curDocFSS);
void HandleMenu (long mSelect);
void SetUpMenus(void);
void InitMacintosh(void);
void HandleMouseDown (EventRecord *theEvent);
void HandleEvent(void);
void SetUpWindow(void);
void ChkOsErr(OSErr);

#define TrapMask 0x0800

static short NumToolboxTraps( void )
{
	if (GetToolTrapAddress(0xA86E) ==
			GetToolTrapAddress(0xAA6E))
		return(0x0200);
	else
		return(0x0400);
}

static TrapType GetTrapType(short theTrap)
{

	if ((theTrap & TrapMask) > 0)
		return(ToolTrap);
	else
		return(OSTrap);

}

static Boolean TrapAvailable(short theTrap)
{

	TrapType	tType;

	tType = GetTrapType(theTrap);
	if (tType == ToolTrap)
		theTrap = theTrap & 0x07FF;
	if (theTrap >= NumToolboxTraps())
		theTrap = 0xA89F;

	return ((tType == ToolTrap?GetToolTrapAddress(theTrap):GetOSTrapAddress(theTrap))!=
			GetToolTrapAddress(0xA89F));
}

/*
 * Attributes stored in the kernel.
 */

long hostid;
int securelevel;
int page_size;

void probe()
	{
	Str255 name,name2;
	int major = 5,minor,cnt;
	long gestaltAnswer,physram,logram;
	if (TrapAvailable(0xA1AD))
		{
		Gestalt(gestaltSystemVersion, &gestaltAnswer);
		major = gestaltAnswer>>8;
		minor = gestaltAnswer&255;
		}
	if (major < 7)
		{
		ParamText((unsigned char *)"\p, Sorry, System 7 required",0,0,0);
		Alert(129, 0);
		ExitToShell();		
		}
	Gestalt(gestaltLogicalPageSize, &gestaltAnswer);
	page_size = gestaltAnswer;
	Gestalt(gestaltLogicalRAMSize, &logram);
	Gestalt(gestaltPhysicalRAMSize, &physram);
	Gestalt(gestaltMachineType, &gestaltAnswer);
	}

int debug = 0;

static Boolean autoquit = true;

TEHandle	TEH;
WindowPtr	progressWindow;
Rect		dragRect;
Rect		windowBounds = { 40, 40, 200, 300 };

void ChkOsErr(OSErr errcode)
	{
	char errno[9],*p = &errno[sizeof(errno)];
	if (errcode < 0)
		{
		errcode = -errcode;
		while (errcode > 0)
			{
			*--p = errcode%10+'0';
			errcode /= 10;
			}
		*--p = '-';
		*--p = &errno[sizeof(errno)]-p;
		ParamText((void *)p, 0, 0, 0);
		Alert(129, 0);
		ExitToShell();
		}
	}

OSErr GotRequiredParams (AppleEvent *theEvent)
	{
	DescType	returnedType;
	long			actualSize;
	OSErr		err;
	
	err = AEGetAttributePtr (theEvent, keyMissedKeywordAttr, typeWildCard, &returnedType, NULL, 0, &actualSize);
	if (err == errAEDescNotFound)
		return noErr;
	else if (err == noErr)
		return errAEEventNotHandled;
	else
		return err;
	}

void HandleOapp (long refcon, AppleEvent *theReply, AppleEvent *theAppleEvent, OSErr errplace)
	{
	autoquit = false;
	errplace = noErr;
#if defined(MOTOROLA)
	ASM(UNLK      A6)
	ASM2(MOVEA.L   (A7)+,A0)
	ASM2(LEA       12(A7),A7)
	ASM(JMP       (A0))
#else
	asm ("\n"
	"unlk      a6\n"
	"movel   a7@+,a0\n"
	"lea       a7@(12),a7\n"
	"jmp       a0@\n"
	);	
#endif
	}

void HandleOdoc (long refcon, AppleEvent *theReply, AppleEvent *theAppleEvent, OSErr err)
	{
	AEDescList		docList;
	
	err = AEGetParamDesc (theAppleEvent, keyDirectObject, typeAEList, &docList);
	if (err == noErr) 
		{
		err = GotRequiredParams (theAppleEvent);
		if (err == noErr)
			{
			long			numDocs, i, actualSize;
			Boolean		wasAlias,isFolder;
			OSErr		err;
			AEKeyword	keyword;
			DescType	returnedType;
	
			err = AECountItems (&docList, &numDocs);
			if (err == noErr) 
				{
				BeginProcessing ();
				for (i = 1; i <= numDocs; i++) 
					{
					FSSpec curDocFSS;
					err = AEGetNthPtr (&docList, i, typeFSS, &keyword, &returnedType,
								(Ptr) &curDocFSS, sizeof (FSSpec), &actualSize);
					if (err == noErr) 
						{
						err = ResolveAliasFile (&curDocFSS, true, &isFolder, &wasAlias);
						if (err == noErr) 
							{
							if (isFolder) scanfolder(&curDocFSS);
							else ProcessDoc(&curDocFSS);
							}
						}
					}
				err = noErr;
				parse();
                                EndProcessing ();
				if (autoquit) ExitToShell();
				}
			}
		(void) AEDisposeDesc (&docList);
		}
#if defined(MOTOROLA)
	ASM(UNLK      A6)
	ASM2(MOVEA.L   (A7)+,A0)
	ASM2(LEA       12(A7),A7)
	ASM(JMP       (A0))
#else
	asm ("\n"
	"unlk      a6\n"
	"movel   a7@+,a0\n"
	"lea       a7@(12),a7\n"
	"jmp       a0@\n"
	);	
#endif
	}

void HandlePdoc (long refcon, AppleEvent *theReply, AppleEvent *theAppleEvent, OSErr err)
{
	AEDescList		docList;
	
	err = AEGetParamDesc (theAppleEvent, keyDirectObject, typeAEList, &docList);
	if (err == noErr) 
		{
		err = GotRequiredParams (theAppleEvent);
		if (err == noErr)
			{
			long			numDocs, i, actualSize;
			Boolean		wasAlias,isFolder;
			OSErr		err;
			AEKeyword	keyword;
			DescType	returnedType;
	
			err = AECountItems (&docList, &numDocs);
			if (err == noErr) 
				{
				BeginProcessing ();
				for (i = 1; i <= numDocs; i++) 
					{
					FSSpec curDocFSS;
					err = AEGetNthPtr (&docList, i, typeFSS, &keyword, &returnedType,
								(Ptr) &curDocFSS, sizeof (FSSpec), &actualSize);
					if (err == noErr) 
						{
						err = ResolveAliasFile (&curDocFSS, true, &isFolder, &wasAlias);
						if (err == noErr) 
						    if (!isFolder)
                                                        {
							ProcessArg(&curDocFSS);
                                                        }
						}
					}
				err = noErr;
				EndProcessing ();
				if (autoquit) ExitToShell();
				}
			}
		(void) AEDisposeDesc (&docList);
		}
#if defined(MOTOROLA)
	ASM(UNLK      A6)
	ASM2(MOVEA.L   (A7)+,A0)
	ASM2(LEA       12(A7),A7)
	ASM(JMP       (A0))
#else
	asm ("\n"
	"unlk      a6\n"
	"movel   a7@+,a0\n"
	"lea       a7@(12),a7\n"
	"jmp       a0@\n"
	);	
#endif
}

static int diedflag;

int wait4(pid_t pid, int *status, int flags, struct rusage *usage)
    {
    int findproc = 1;
    FSSpec aFSSpec;
    ProcessSerialNumber defaultResult = {0};
    ProcessInfoRec InfoRec;
//    ZeroScrap();
    defaultResult.highLongOfPSN = 0;
    defaultResult.lowLongOfPSN = kNoProcess;
    InfoRec.processInfoLength = sizeof(ProcessInfoRec);
    InfoRec.processName = (StringPtr) NewPtr(32);
    InfoRec.processAppSpec = &aFSSpec;

    while (findproc && (GetNextProcess(&defaultResult) == noErr) &&
    (defaultResult.highLongOfPSN|defaultResult.lowLongOfPSN))
          {
          OSErr err = GetProcessInformation(&defaultResult,&InfoRec);
          if (defaultResult.lowLongOfPSN==pid)
                        {
//                        fsdebug(aFSSpec);
                        SetFrontProcess(&defaultResult);
                        findproc = 0;
                        }
          if ((err == noErr) && (InfoRec.processType == 'FNDR'))
                        {
//                        fsdebug(aFSSpec);
                        SetFrontProcess(&defaultResult);
                        }
            }
//    kprintf("Waiting for sub-process\n");
    diedflag = 0;
    do  {
        mysleep(2);

        }
    while (!diedflag);
//    TEPaste(crt_TEH);
    if (status) *status = 0;
    return diedflag;
    }

void HandleDied (long refcon, AppleEvent *theReply, AppleEvent *theAppleEvent, OSErr err)
{
	DescType		returnedType;
        ProcessSerialNumber     defaultResult;
        Size                    actualSize;
//	kprintf("sub-process died\n");
	err = AEGetParamPtr (theAppleEvent, keyProcessSerialNumber, typeWildCard, &returnedType, (Ptr)&defaultResult, sizeof(defaultResult), &actualSize);
	if (err == noErr) 
		{
//                kprintf("Actual size = %X\n", actualSize);
//                kprintf("Actual data = %X\n", defaultResult.highLongOfPSN);
//                kprintf("Actual data = %X\n", defaultResult.lowLongOfPSN);
//                diedflag = (defaultResult.highLongOfPSN^defaultResult.lowLongOfPSN)%32767+1;
                diedflag = defaultResult.lowLongOfPSN;
//                kprintf("Actual flag = %X\n", diedflag);
		}
        else kprintf("AEGetParamPtr failed, err = %d\n", err);
#if defined(MOTOROLA)
	ASM(UNLK      A6)
	ASM2(MOVEA.L   (A7)+,A0)
	ASM2(LEA       12(A7),A7)
	ASM(JMP       (A0))
#else
	asm ("\n"
	"unlk      a6\n"
	"movel   a7@+,a0\n"
	"lea       a7@(12),a7\n"
	"jmp       a0@\n"
	);	
#endif
}

void HandleQuit (long refcon, AppleEvent *theReply, AppleEvent *theAppleEvent, OSErr errplace)
{
	ExitToShell();
	errplace = noErr;
#if defined(MOTOROLA)
	ASM(UNLK      A6)
	ASM2(MOVEA.L   (A7)+,A0)
	ASM2(LEA       12(A7),A7)
	ASM(JMP       (A0))
#else
	asm ("\n"
	"unlk      a6\n"
	"movel   a7@+,a0\n"
	"lea       a7@(12),a7\n"
	"jmp       a0@\n"
	);	
#endif
}

void ReturnEventNotHandled (long refcon, AppleEvent *theReply, AppleEvent *theAppleEvent, OSErr errplace)
{
	errplace = errAEEventNotHandled;
#if defined(MOTOROLA)
	ASM(UNLK      A6)
	ASM2(MOVEA.L   (A7)+,A0)
	ASM2(LEA       12(A7),A7)
	ASM(JMP       (A0))
#else
	asm ("\n"
	"unlk      a6\n"
	"movel   a7@+,a0\n"
	"lea       a7@(12),a7\n"
	"jmp       a0@\n"
	);	
#endif
}

void start(void)
	{
	InitMacintosh();
	SetUpMenus();
	SetUpWindow();

/* maintain compatibility with non universal headers */
#ifndef NewAEEventHandlerProc
#define NewAEEventHandlerProc(x) x
#endif

	AEInstallEventHandler (kCoreEventClass, kAEOpenApplication, NewAEEventHandlerProc(HandleOapp), 0, false);
	AEInstallEventHandler (kCoreEventClass, kAEOpenDocuments, NewAEEventHandlerProc(HandleOdoc), 0, false);
	AEInstallEventHandler (kCoreEventClass, kAEPrintDocuments, NewAEEventHandlerProc(HandlePdoc), 0, false);
	AEInstallEventHandler (kCoreEventClass, kAEQuitApplication, NewAEEventHandlerProc(HandleQuit), 0, false);
	AEInstallEventHandler (kCoreEventClass, kAEApplicationDied, NewAEEventHandlerProc(HandleDied), 0, false);
	for (;;)
		HandleEvent();
}
/* end main */



MenuHandle	appleMenu, fileMenu, editMenu;

enum	{
	appleID = 1,
	fileID,
	editID
	};

enum	{
	openItem = 1,
	closeItem,
	quitItem = 4
	};

void SetUpMenus(void)
{
	InsertMenu(appleMenu = NewMenu(appleID, (unsigned char *)"\001\024"), 0);
	InsertMenu(fileMenu = NewMenu(fileID, (unsigned char *)"\004File"), 0);
	DrawMenuBar();
	AppendMenu(appleMenu, (unsigned char *)"\011About ...");
	AddResMenu(appleMenu, 'DRVR');
	AppendMenu(fileMenu, (unsigned char *)"\pOpen/O;Flags/L;Quit/Q;Toggle debug/D");
}
/* end SetUpMenus */

void HandleMenu(long mSelect)
{
	int			menuID = HiWord(mSelect);
	int			menuItem = LoWord(mSelect);
	Str255		name;
	GrafPtr		savePort;
	WindowPeek	frontWindow;
	
	switch (menuID)
	  {
	  case	appleID:
	  	switch(menuItem)
	  		{
	  		case 1: 
	  			{
	  			UpdateFileName((StringPtr)"\005Hello");
				}
	  		break;
	  		default:
			GetPort(&savePort);
			GetItem(appleMenu, menuItem, name);
			OpenDeskAcc(name);
			SetPort(savePort);
			}
		break;
	
	  case	fileID:
	  	switch(menuItem)
	  		{
	  		case 1: 
	  			{
				long		aProcID;
	  			SFReply macSFReply;
	  			FSSpec new;
				Point	where;
				SFTypeList	typeList;
			
				typeList[0]='TEXT';	/* file type to search for */
				where.h=20;  where.v=90;	/* SF dialog window position */
			
				SFGetFile(where,		/* put topLeft corner of dialog box here */
							(ConstStr255Param)0,			/* always 0 on SFGetFile() */
							(ProcPtr)0,			/* address of custom filter */
							1,			/* only looking for one file type */
							typeList,	/* start of list of file types */
							(ProcPtr)0, 	/* use standard dialog handler */
							&macSFReply);	/* put results here */

				if ( macSFReply.good ) 
					{ 
					WDPBRec	wdpb;
					wdpb.ioNamePtr = 0;
					wdpb.ioVRefNum = macSFReply.vRefNum;
					wdpb.ioWDIndex =0;
					wdpb.ioWDProcID =0;
					wdpb.ioWDVRefNum =0;
					PBGetWDInfoSync( &wdpb );
					new.parID = wdpb.ioWDDirID;
					new.vRefNum = wdpb.ioWDVRefNum;
		  			BlockMove(macSFReply.fName, new.name, macSFReply.fName[0]+1);
		  			BeginProcessing();
		  			ProcessDoc(&new);
                                        parse();
		  			EndProcessing();
					}
	  			}
	  		break;
			case 2: 
				{
				crt_getargs();
				break;
				}
			case 3: ExitToShell();
			case 4: debug = !debug; break;
			}
		break;
  				
	  }
}
/* end HandleMenu */


void SetUpWindow(void)

{
	dragRect = qd.screenBits.bounds;
	
	progressWindow = NewWindow(0L, &windowBounds, (unsigned char *)"\010progress", 
		true, noGrowDocProc, (WindowPtr) -1L, true, 0);
	SetPort(progressWindow);
	TEH = TENew(&windowBounds, &windowBounds);
}
/* end SetUpWindow */


void InitMacintosh(void)

{
//	MaxApplZone();
	
	InitGraf(&qd.thePort);
	InitFonts();
	FlushEvents(everyEvent, 0);
	InitWindows();
	InitMenus();
	TEInit();
	InitDialogs(0L);
	InitCursor();
        probe();
}
/* end InitMacintosh */

void HandleMouseDown (EventRecord	*theEvent)

{
	WindowPtr	theWindow;
	int			windowCode = FindWindow (theEvent->where, &theWindow);
	
    switch (windowCode)
      {
	  case inSysWindow: 
	    SystemClick (theEvent, theWindow);
	    break;
	    
	  case inMenuBar:
	    HandleMenu(MenuSelect(theEvent->where));
	    break;
	    
	  case inDrag:
	  	if (theWindow == progressWindow)
	  	  DragWindow(progressWindow, theEvent->where, &dragRect);
	  	  break;
	  	  
	  case inContent:
	  	if (theWindow == progressWindow)
	  	  {
	  	  if (theWindow != FrontWindow())
	  	    SelectWindow(progressWindow);
	  	  else
	  	    InvalRect(&progressWindow->portRect);
	  	  }
	  	break;
	  	
	  case inGoAway:
	  	if (theWindow == progressWindow && 
	  		TrackGoAway(progressWindow, theEvent->where))
		  HideWindow(progressWindow);
	  	  break;
      }
}
/* end HandleMouseDown */

void HandleEvent(void)
{
	int			ok;
	EventRecord	theEvent;

	HiliteMenu(0);
	SystemTask ();		/* Handle desk accessories */
	
	ok = WaitNextEvent (everyEvent, &theEvent, 20, 0);
	if (ok)
	  switch (theEvent.what)
	    {
		case mouseDown:
			HandleMouseDown(&theEvent);
			break;
			
		case keyDown: 
		case autoKey:
		    if ((theEvent.modifiers & cmdKey) != 0)
		      {
			  HandleMenu(MenuKey((char) (theEvent.message & charCodeMask)));
			  }
			break;
			
		case updateEvt:
			{
			Rect upper = progressWindow->portRect;
			Rect lower = progressWindow->portRect;
			upper.bottom = upper.top + 32;
			lower.top = upper.bottom;
			BeginUpdate(progressWindow);
			SetPort(progressWindow);
			EraseRect(&lower);
			upper.right = lower.right;
			FillRect(&upper,(void *)&qd.white);
			TEUpdate(&progressWindow->portRect, TEH);
			EndUpdate(progressWindow);
		    break;
		    }
		case activateEvt:
			InvalRect(&progressWindow->portRect);
			break;

		case kHighLevelEvent:
			AEProcessAppleEvent (&theEvent);
			break;
	    }
}
/* end HandleEvent */

void	UpdateFileName(StringPtr name)
	{
	Rect upper = progressWindow->portRect;
	Rect lower = progressWindow->portRect;
	upper.bottom = upper.top + 32;
	lower.top = upper.bottom;
	TESetText(&(name[1]),name[0],TEH);
	InvalRect(&lower);
	HandleEvent();
	}
